/* Declare mesh.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_MESH_H__



// signals file inclusion
#define __3DFC_MESH_H__



class CMesh {

public:

   CMesh ();
   ~CMesh ();

public:

   // mesh data
   CList m_oPolygons;    // polygon definition: index of vertexes, start in 0
   CList m_oVertexes;    // vertexes of mesh in space (nodes of CNodeVertex)
   CMap  m_oPortals;     // portal polygons between 2 sectors

   BOOL mBeginAddMesh ();
   BOOL mEndAddMesh ();
   void mDestroy ();
   BOOL mSetPolygonsLight ( float fLight, DWORD dwLightID, INT nNdxPol1, INT nNdxPol2 );
   BOOL mSetPolygonsAttributes ( BOOL bPortal, BYTE yCrossable, DWORD dwTextureID,
                                 INT nNdxPol1, INT nNdxPol2 );
   BOOL mAddPolygon ( CList& oIndexes );
   BOOL mAddPolygon ( CNodePolygon* poSrc );
   BOOL mAddVertex ( INT nX, INT nY, INT nZ, BOOL bScale );
   BOOL mAddPortal ( DWORD dwNdxPol, DWORD dwObjectID, DWORD dwSectorID );
};



// end declarations
#endif
