/* Declare scenery.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_SCENERY_H__



// signals file inclusion
#define __3DFC_SCENERY_H__



class CScenery {

public:

   CScenery ();
   CScenery ( CString oszFile );
   ~CScenery ();

private:

   // used when creating the scenery only
   DWORD m_dwObjectID;       // ID of current object beeing defined
   DWORD m_dwSectorID;       // ID of current sector beeing defined
   BOOL m_bDefiningObject;   // if TRUE object beeing defined else a sector
                             // With this polygons, vertexes and attributes
                             // beeing added refer to object (if TRUE) or to
                             // sector (if FALSE).

public:

   BOOL mCreate ( CString oszFile );
   void mDestroy ();

   // scenery data
   CMem m_oPal;               // palette
   CMap m_oLightTables;       // light tables
   CMap m_oTextures;          // texture set
   CMap m_oObjects;           // object models available for instanciation
   CNodeSector m_oRootInstances;  // object instances in first (top) level

   // frame buffer configuration
   INT  m_nClearBackground;  // background color to clear frame buff (-1 no clear)

   // camera configuration
   DWORD m_dwCameraID;    // object instance that is the camera
   DWORD m_dwInsideObjID; // parent camera instance (inside who camera is)
   DWORD m_dwInsideSecID; // parent sector (where, what sector, the camera is)

   BOOL mAddPalette ( CMem oPal );
   BOOL mAddLightTable ( CLightTable& oLgT, DWORD dwID, CString oszFile,
                         DWORD dwNumLevels, float fR, float fG, float fB );
   BOOL mAddTexture ( DWORD dwID, CTexture& oTx );

   // REVIEW por em controle the objetos
   BOOL mAddInstance ( DWORD dwInstID, DWORD dwObjectID,
                       DWORD dwDestinInstID,DWORD dwDestinSectorID,
                       tagXYZ& stPos, tagfXYZ& stI,
                       tagfXYZ& stJ, tagfXYZ& stK,
                       BOOL bCopyData );
   void mMoveInstance ( CNodeObject& oObj, DWORD dwObjID,
                        CNodeSector& oParentSec,
                        DWORD dwDestinObjID, DWORD dwDestinSecID );
   void mInvertCamera ( CCameraSystem& oCamSys );

   BOOL mBeginAddObject ( DWORD dwObjID );
   BOOL mEndAddObject ();
   BOOL mBeginAddSector ( DWORD dwSectorID );
   BOOL mEndAddSector ();
   BOOL mSetPolygonsLight ( float fLight, DWORD dwLightID, INT nNdxPol1, INT nNdxPol2 );
   BOOL mSetPolygonsAttributes ( BOOL bPortal, BYTE yCrossable, DWORD dwTextureID,
                                 INT nNdxPol1, INT nNdxPol2 );
   BOOL mAddPolygon ( CList& oIndexes );
   BOOL mAddVertex ( INT nX, INT nY, INT nZ, BOOL bScale );
   BOOL mAddPortal ( DWORD dwNdxPol, DWORD dwObjectID, DWORD dwSectorID );
   BOOL mSetStart ( DWORD dwCameraID, DWORD dwObjID, DWORD dwSecID, INT nClear );
   BOOL mSetCurrentCamera ( DWORD dwCameraID, DWORD dwObjID, DWORD dwSecID );
};



// end declarations
#endif
